#pragma GCC optimize ("O3")
#include "bits/stdc++.h"
using namespace std;

#define rep(i, b, e) for(int i = (b); i <= (e); i++)
#define per(i, b, e) for(int i = (e); i >= (b); i--)
#define FOR(i, b, e) rep(i, b, (e) - 1)
#define SZ(x) int(x.size())
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define st first
#define nd second
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

auto &operator<<(auto &o, pair<auto, auto> p) {
    return o << "(" << p.st << ", " << p.nd << ")";
}

auto operator<<(auto &o, auto x)->decltype(end(x), o) {
    o << "{"; int i=0; for(auto e: x) o << ", " + 2*!i++ << e;
    return o << "}";
}

#ifdef LOCAL
#define deb(x...) cerr << "[" #x << "]: ", [](auto...$) { ((cerr << $ << "; "),...) << endl; }(x)
#else
#define deb(...)
#endif

mt19937 rng(chrono::high_resolution_clock::now().time_since_epoch().count());
const int N=24;
int czy[1<<N][N];
bool good(vector<vector<int> > V){
    int n=V.size();
    for(int i=0; i<n; i++){
        czy[1<<i][i]=3;
    }
    int maks=0;
    for(int i=0; i<(1<<n); i++){
        for(int j=0; j<n; j++){
            if(czy[i][j]){
                //deb(i, j, czy[i][j]);
                maks=max(maks, __builtin_popcount(i));
                for(int k=0; k<n; k++){
                    if(!(i&(1<<k))){
                        czy[i|(1<<k)][k]|=(czy[i][j]&V[k][j]);
                    }
                }
            }
            czy[i][j]=0;
        }
    }
    deb(maks);
    deb((3*n+3)/4+1);
    if(maks>1+(3*n+3)/4)return 0;
    return 1;
}
vector<vector<int>> gen_test(int n){
    vector<vector<int> > V(n, vi(n));
    for(int i=0; i<n/2; i++){
        int a=rng()%n, b=rng()%(n-1);
        if(b>=a)b++;
        int c=1+(rng()&1);
        V[a][b]=V[b][a]=c;
    }
    return V;
}

void solve() {
    int n=20;
    cin>>n;
    vector<vector<int> > sta(n, vi(n));
    for(int i=0; i<n; i++){
        string s;
        cin>>s;
        for(int j=0; j<n; j++){
            if(s[j]=='F')sta[i][j]=1;
            if(s[j]=='S')sta[i][j]=2;
        }
    }
    //sta=gen_test(n);
    deb(sta);
    int dozwolone=1+(3*n+3)/4;
    //deb(dozwolone);
    for(int mask=0; mask<(1<<n); mask++){
        int bity=__builtin_popcount(mask);
        if(bity*2+1>dozwolone || n-bity>dozwolone)continue;
        int reszta=0, pomiedzy=0;
        bool dobrze=1;
        for(int i=0; i<n; i++){
            bool czyi=!!(mask&(1<<i));
            for(int j=0; j<i; j++){
                if(mask&(1<<j)){
                    if(!czyi && sta[i][j] && pomiedzy!=sta[i][j]){
                        if(pomiedzy)dobrze=0;
                        else pomiedzy=sta[i][j];
                    }
                }
                else{
                    if(czyi && sta[i][j] && pomiedzy!=sta[i][j]){
                        if(pomiedzy)dobrze=0;
                        else pomiedzy=sta[i][j];
                    }
                    if(!czyi && sta[i][j] && reszta!=sta[i][j]){
                        if(reszta)dobrze=0;
                        else reszta=sta[i][j];
                    }
                }
            }
            if(pomiedzy && reszta==pomiedzy)dobrze=0;
            if(!dobrze)break;
        }
        if(pomiedzy==0 && reszta==0)pomiedzy=1, reszta=2;
        else if(pomiedzy)reszta=3^pomiedzy;
        else if(reszta) pomiedzy=3^reszta;
        if(dobrze){
            deb(bity, mask);
            auto V=sta;
            for(int i=0; i<n; i++){
                for(int j=0; j<n; j++){
                    if(i!=j && !sta[i][j]){
                        if(!(mask&(1<<j)) && !(mask&(1<<i)))V[i][j]=reszta;
                        else V[i][j]=pomiedzy;                       
                    }
                }
            }
            for(int i=0; i<n; i++){
                for(int j=0; j<n; j++){
                    if(i==j)cout<<".";
                    else if(V[i][j]==2)cout<<"S";
                    else cout<<"F";
                }
                cout<<"\n";
            }
            //assert(good(V));
            return;
        }
    }
    assert(false);
    /*while(true){
        auto V=sta;
        for(int i=0; i<n; i++){
            for(int j=0; j<i; j++){
                //int a=1+(rng()&1);
                int a=(__builtin_popcount(i&j)&1)+1;
                V[i][j]=V[j][i]=a;
            }
        }
        if(good(V)){
            for(int i=0; i<n; i++){
                for(int j=0; j<n; j++){
                    if(i==j)cout<<".";
                    else if(V[i][j]==2)cout<<"S";
      0              else cout<<"F";
                }
                cout<<"\n";
            }
            break;
        }
        else{
            /*deb("a");
            for(int i=0; i<n; i++){
                for(int j=0; j<n; j++){
                    if(i==j)cout<<".";
                    else if(V[i][j]==2)cout<<"S";
                    else cout<<"F";
                }
                cout<<"\n";
            }
            //break;
        }
    }*/
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int tt = 1;
    //cin >> tt;
    FOR(te, 0, tt) solve();
    return 0;
}