#pragma GCC optimize ("O3")
#include "bits/stdc++.h"
using namespace std;

#define rep(i, b, e) for(int i = (b); i <= (e); i++)
#define per(i, b, e) for(int i = (e); i >= (b); i--)
#define FOR(i, b, e) rep(i, b, (e) - 1)
#define SZ(x) int(x.size())
#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define st first
#define nd second
using ll = long long;
using pii = pair<int, int>;
using vi = vector<int>;

auto &operator<<(auto &o, pair<auto, auto> p) {
    return o << "(" << p.st << ", " << p.nd << ")";
}

auto operator<<(auto &o, auto x)->decltype(end(x), o) {
    o << "{"; int i=0; for(auto e: x) o << ", " + 2*!i++ << e;
    return o << "}";
}

#ifdef LOCAL
#define deb(x...) cerr << "[" #x << "]: ", [](auto...$) { ((cerr << $ << "; "),...) << endl; }(x)
#else
#define deb(...)
#endif

const int N = 18 * 18;
using B = bitset<N>;

B lans;
int ans;

map<pii, vector<pii>> memo = {
{{16, 1}, {{1, 1}, {1, 2}, {1, 3}, {1, 4}, {1, 5}, {1, 6}, {1, 7}, {1, 8}, {1, 9}, {1, 10}, {1, 11}, {1, 12}, {1, 13}, {1, 14}, {1, 15}, {2, 1}, {2, 2}, {2, 3}, {2, 4}, {2, 5}, {2, 6}, {2, 7}, {2, 8}, {2, 9}, {2, 10}, {2, 11}, {2, 12}, {2, 13}, {2, 14}, {2, 15}, {3, 1}, {3, 2}, {3, 3}, {3, 4}, {3, 5}, {3, 6}, {3, 7}, {3, 8}, {3, 9}, {3, 10}, {3, 11}, {3, 12}, {3, 13}, {3, 14}, {3, 15}, {4, 1}, {4, 2}, {4, 3}, {4, 4}, {4, 5}, {4, 6}, {4, 7}, {4, 8}, {4, 9}, {4, 10}, {4, 11}, {4, 12}, {4, 13}, {4, 14}, {4, 15}, {5, 1}, {5, 2}, {5, 3}, {5, 4}, {5, 5}, {5, 6}, {5, 7}, {5, 8}, {5, 9}, {5, 10}, {5, 11}, {5, 12}, {5, 13}, {5, 14}, {5, 15}, {6, 1}, {6, 2}, {6, 3}, {6, 4}, {6, 5}, {6, 6}, {6, 7}, {6, 8}, {6, 9}, {6, 10}, {6, 11}, {6, 12}, {6, 13}, {6, 14}, {6, 15}, {7, 1}, {7, 2}, {7, 3}, {7, 4}, {7, 5}, {7, 6}, {7, 7}, {7, 8}, {7, 9}, {7, 10}, {7, 11}, {7, 12}, {7, 13}, {7, 14}, {7, 15}, {8, 1}, {8, 2}, {8, 3}, {8, 4}, {8, 5}, {8, 6}, {8, 7}, {8, 8}, {8, 9}, {8, 10}, {8, 11}, {8, 12}, {8, 13}, {8, 14}, {8, 15}, {9, 1}, {9, 2}, {9, 3}, {9, 4}, {9, 5}, {9, 6}, {9, 7}, {9, 8}, {9, 9}, {9, 10}, {9, 11}, {9, 12}, {9, 13}, {9, 14}, {9, 15}, {10, 1}, {10, 2}, {10, 3}, {10, 4}, {10, 5}, {10, 6}, {10, 7}, {10, 8}, {10, 9}, {10, 10}, {10, 11}, {10, 12}, {10, 13}, {10, 14}, {10, 15}, {11, 1}, {11, 2}, {11, 3}, {11, 4}, {11, 5}, {11, 6}, {11, 7}, {11, 8}, {11, 9}, {11, 10}, {11, 11}, {11, 12}, {11, 13}, {11, 14}, {11, 15}, {12, 1}, {12, 2}, {12, 3}, {12, 4}, {12, 5}, {12, 6}, {12, 7}, {12, 8}, {12, 9}, {12, 10}, {12, 11}, {12, 12}, {12, 13}, {12, 14}, {12, 15}, {13, 1}, {13, 2}, {13, 3}, {13, 4}, {13, 5}, {13, 6}, {13, 7}, {13, 8}, {13, 9}, {13, 10}, {13, 11}, {13, 12}, {13, 13}, {13, 14}, {13, 15}, {14, 1}, {14, 2}, {14, 3}, {14, 4}, {14, 5}, {14, 6}, {14, 7}, {14, 8}, {14, 9}, {14, 10}, {14, 11}, {14, 12}, {14, 13}, {14, 14}, {14, 15}, {15, 1}, {15, 2}, {15, 3}, {15, 4}, {15, 5}, {15, 6}, {15, 7}, {15, 8}, {15, 9}, {15, 10}, {15, 11}, {15, 12}, {15, 13}, {15, 14}, {15, 15}}}, 
{{16, 2}, {{1, 1}, {1, 3}, {1, 5}, {1, 7}, {1, 9}, {1, 11}, {1, 13}, {1, 15}, {2, 2}, {2, 4}, {2, 6}, {2, 8}, {2, 10}, {2, 12}, {2, 14}, {3, 1}, {3, 3}, {3, 5}, {3, 7}, {3, 9}, {3, 11}, {3, 13}, {3, 15}, {4, 2}, {4, 4}, {4, 6}, {4, 8}, {4, 10}, {4, 12}, {4, 14}, {5, 1}, {5, 3}, {5, 5}, {5, 7}, {5, 9}, {5, 11}, {5, 13}, {5, 15}, {6, 2}, {6, 4}, {6, 6}, {6, 8}, {6, 10}, {6, 12}, {6, 14}, {7, 1}, {7, 3}, {7, 5}, {7, 7}, {7, 9}, {7, 11}, {7, 13}, {7, 15}, {8, 2}, {8, 4}, {8, 6}, {8, 8}, {8, 10}, {8, 12}, {8, 14}, {9, 1}, {9, 3}, {9, 5}, {9, 7}, {9, 9}, {9, 11}, {9, 13}, {9, 15}, {10, 2}, {10, 4}, {10, 6}, {10, 8}, {10, 10}, {10, 12}, {10, 14}, {11, 1}, {11, 3}, {11, 5}, {11, 7}, {11, 9}, {11, 11}, {11, 13}, {11, 15}, {12, 2}, {12, 4}, {12, 6}, {12, 8}, {12, 10}, {12, 12}, {12, 14}, {13, 1}, {13, 3}, {13, 5}, {13, 7}, {13, 9}, {13, 11}, {13, 13}, {13, 15}, {14, 2}, {14, 4}, {14, 6}, {14, 8}, {14, 10}, {14, 12}, {14, 14}, {15, 1}, {15, 3}, {15, 5}, {15, 7}, {15, 9}, {15, 11}, {15, 13}, {15, 15}}}, 
{{16, 4}, {{1, 1}, {1, 3}, {1, 5}, {1, 7}, {1, 9}, {1, 11}, {1, 13}, {1, 15}, {3, 1}, {3, 3}, {3, 5}, {3, 7}, {3, 9}, {3, 11}, {3, 13}, {3, 15}, {5, 1}, {5, 3}, {5, 5}, {5, 7}, {5, 9}, {5, 11}, {5, 13}, {5, 15}, {7, 1}, {7, 3}, {7, 5}, {7, 7}, {7, 9}, {7, 11}, {7, 13}, {7, 15}, {9, 1}, {9, 3}, {9, 5}, {9, 7}, {9, 9}, {9, 11}, {9, 13}, {9, 15}, {11, 1}, {11, 3}, {11, 5}, {11, 7}, {11, 9}, {11, 11}, {11, 13}, {11, 15}, {13, 1}, {13, 3}, {13, 5}, {13, 7}, {13, 9}, {13, 11}, {13, 13}, {13, 15}, {15, 1}, {15, 3}, {15, 5}, {15, 7}, {15, 9}, {15, 11}, {15, 13}, {15, 15}}}, 
{{16, 5}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {4, 3}, {4, 6}, {4, 9}, {4, 12}, {5, 14}, {6, 2}, {6, 5}, {6, 8}, {6, 11}, {7, 13}, {8, 3}, {8, 6}, {8, 9}, {9, 11}, {9, 14}, {10, 2}, {10, 5}, {10, 8}, {11, 10}, {11, 13}, {12, 3}, {12, 6}, {13, 8}, {13, 11}, {13, 14}, {14, 2}, {14, 5}}}, 
{{16, 8}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {5, 2}, {5, 5}, {5, 8}, {5, 11}, {5, 14}, {8, 2}, {8, 5}, {8, 8}, {8, 11}, {8, 14}, {11, 2}, {11, 5}, {11, 8}, {11, 11}, {11, 14}, {14, 2}, {14, 5}, {14, 8}, {14, 11}, {14, 14}}}, 
{{16, 9}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {5, 2}, {5, 5}, {5, 8}, {5, 11}, {5, 14}, {8, 2}, {8, 5}, {8, 8}, {8, 11}, {8, 14}, {11, 2}, {11, 5}, {11, 8}, {11, 11}, {11, 14}, {14, 2}, {14, 5}, {14, 8}, {14, 11}, {14, 14}}}, 
{{16, 10}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {5, 3}, {5, 7}, {5, 11}, {6, 14}, {8, 2}, {8, 6}, {8, 10}, {9, 13}, {11, 3}, {11, 7}, {12, 10}, {12, 14}, {14, 2}, {14, 6}}}, 
{{16, 13}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {5, 4}, {5, 8}, {5, 12}, {8, 2}, {8, 6}, {8, 10}, {8, 14}, {11, 4}, {11, 8}, {11, 12}, {14, 2}, {14, 6}, {14, 10}, {14, 14}}}, 
{{16, 16}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {6, 2}, {6, 6}, {6, 10}, {6, 14}, {10, 2}, {10, 6}, {10, 10}, {10, 14}, {14, 2}, {14, 6}, {14, 10}, {14, 14}}}, 
{{16, 17}, {{3, 3}, {3, 8}, {3, 13}, {7, 4}, {7, 9}, {8, 13}, {11, 3}, {11, 8}, {12, 12}}}, 
{{16, 18}, {{3, 3}, {3, 8}, {3, 13}, {7, 10}, {8, 3}, {10, 7}, {10, 13}, {13, 3}, {13, 10}}}, 
{{17, 1}, {{1, 1}, {1, 2}, {1, 3}, {1, 4}, {1, 5}, {1, 6}, {1, 7}, {1, 8}, {1, 9}, {1, 10}, {1, 11}, {1, 12}, {1, 13}, {1, 14}, {1, 15}, {1, 16}, {2, 1}, {2, 2}, {2, 3}, {2, 4}, {2, 5}, {2, 6}, {2, 7}, {2, 8}, {2, 9}, {2, 10}, {2, 11}, {2, 12}, {2, 13}, {2, 14}, {2, 15}, {2, 16}, {3, 1}, {3, 2}, {3, 3}, {3, 4}, {3, 5}, {3, 6}, {3, 7}, {3, 8}, {3, 9}, {3, 10}, {3, 11}, {3, 12}, {3, 13}, {3, 14}, {3, 15}, {3, 16}, {4, 1}, {4, 2}, {4, 3}, {4, 4}, {4, 5}, {4, 6}, {4, 7}, {4, 8}, {4, 9}, {4, 10}, {4, 11}, {4, 12}, {4, 13}, {4, 14}, {4, 15}, {4, 16}, {5, 1}, {5, 2}, {5, 3}, {5, 4}, {5, 5}, {5, 6}, {5, 7}, {5, 8}, {5, 9}, {5, 10}, {5, 11}, {5, 12}, {5, 13}, {5, 14}, {5, 15}, {5, 16}, {6, 1}, {6, 2}, {6, 3}, {6, 4}, {6, 5}, {6, 6}, {6, 7}, {6, 8}, {6, 9}, {6, 10}, {6, 11}, {6, 12}, {6, 13}, {6, 14}, {6, 15}, {6, 16}, {7, 1}, {7, 2}, {7, 3}, {7, 4}, {7, 5}, {7, 6}, {7, 7}, {7, 8}, {7, 9}, {7, 10}, {7, 11}, {7, 12}, {7, 13}, {7, 14}, {7, 15}, {7, 16}, {8, 1}, {8, 2}, {8, 3}, {8, 4}, {8, 5}, {8, 6}, {8, 7}, {8, 8}, {8, 9}, {8, 10}, {8, 11}, {8, 12}, {8, 13}, {8, 14}, {8, 15}, {8, 16}, {9, 1}, {9, 2}, {9, 3}, {9, 4}, {9, 5}, {9, 6}, {9, 7}, {9, 8}, {9, 9}, {9, 10}, {9, 11}, {9, 12}, {9, 13}, {9, 14}, {9, 15}, {9, 16}, {10, 1}, {10, 2}, {10, 3}, {10, 4}, {10, 5}, {10, 6}, {10, 7}, {10, 8}, {10, 9}, {10, 10}, {10, 11}, {10, 12}, {10, 13}, {10, 14}, {10, 15}, {10, 16}, {11, 1}, {11, 2}, {11, 3}, {11, 4}, {11, 5}, {11, 6}, {11, 7}, {11, 8}, {11, 9}, {11, 10}, {11, 11}, {11, 12}, {11, 13}, {11, 14}, {11, 15}, {11, 16}, {12, 1}, {12, 2}, {12, 3}, {12, 4}, {12, 5}, {12, 6}, {12, 7}, {12, 8}, {12, 9}, {12, 10}, {12, 11}, {12, 12}, {12, 13}, {12, 14}, {12, 15}, {12, 16}, {13, 1}, {13, 2}, {13, 3}, {13, 4}, {13, 5}, {13, 6}, {13, 7}, {13, 8}, {13, 9}, {13, 10}, {13, 11}, {13, 12}, {13, 13}, {13, 14}, {13, 15}, {13, 16}, {14, 1}, {14, 2}, {14, 3}, {14, 4}, {14, 5}, {14, 6}, {14, 7}, {14, 8}, {14, 9}, {14, 10}, {14, 11}, {14, 12}, {14, 13}, {14, 14}, {14, 15}, {14, 16}, {15, 1}, {15, 2}, {15, 3}, {15, 4}, {15, 5}, {15, 6}, {15, 7}, {15, 8}, {15, 9}, {15, 10}, {15, 11}, {15, 12}, {15, 13}, {15, 14}, {15, 15}, {15, 16}, {16, 1}, {16, 2}, {16, 3}, {16, 4}, {16, 5}, {16, 6}, {16, 7}, {16, 8}, {16, 9}, {16, 10}, {16, 11}, {16, 12}, {16, 13}, {16, 14}, {16, 15}, {16, 16}}}, 
{{17, 2}, {{1, 1}, {1, 3}, {1, 5}, {1, 7}, {1, 9}, {1, 11}, {1, 13}, {1, 15}, {2, 2}, {2, 4}, {2, 6}, {2, 8}, {2, 10}, {2, 12}, {2, 14}, {2, 16}, {3, 1}, {3, 3}, {3, 5}, {3, 7}, {3, 9}, {3, 11}, {3, 13}, {3, 15}, {4, 2}, {4, 4}, {4, 6}, {4, 8}, {4, 10}, {4, 12}, {4, 14}, {4, 16}, {5, 1}, {5, 3}, {5, 5}, {5, 7}, {5, 9}, {5, 11}, {5, 13}, {5, 15}, {6, 2}, {6, 4}, {6, 6}, {6, 8}, {6, 10}, {6, 12}, {6, 14}, {6, 16}, {7, 1}, {7, 3}, {7, 5}, {7, 7}, {7, 9}, {7, 11}, {7, 13}, {7, 15}, {8, 2}, {8, 4}, {8, 6}, {8, 8}, {8, 10}, {8, 12}, {8, 14}, {8, 16}, {9, 1}, {9, 3}, {9, 5}, {9, 7}, {9, 9}, {9, 11}, {9, 13}, {9, 15}, {10, 2}, {10, 4}, {10, 6}, {10, 8}, {10, 10}, {10, 12}, {10, 14}, {10, 16}, {11, 1}, {11, 3}, {11, 5}, {11, 7}, {11, 9}, {11, 11}, {11, 13}, {11, 15}, {12, 2}, {12, 4}, {12, 6}, {12, 8}, {12, 10}, {12, 12}, {12, 14}, {12, 16}, {13, 1}, {13, 3}, {13, 5}, {13, 7}, {13, 9}, {13, 11}, {13, 13}, {13, 15}, {14, 2}, {14, 4}, {14, 6}, {14, 8}, {14, 10}, {14, 12}, {14, 14}, {14, 16}, {15, 1}, {15, 3}, {15, 5}, {15, 7}, {15, 9}, {15, 11}, {15, 13}, {15, 15}, {16, 2}, {16, 4}, {16, 6}, {16, 8}, {16, 10}, {16, 12}, {16, 14}, {16, 16}}}, 
{{17, 4}, {{1, 1}, {1, 3}, {1, 5}, {1, 7}, {1, 9}, {1, 11}, {1, 13}, {1, 15}, {3, 1}, {3, 3}, {3, 5}, {3, 7}, {3, 9}, {3, 11}, {3, 13}, {3, 15}, {5, 1}, {5, 3}, {5, 5}, {5, 7}, {5, 9}, {5, 11}, {5, 13}, {5, 15}, {7, 1}, {7, 3}, {7, 5}, {7, 7}, {7, 9}, {7, 11}, {7, 13}, {7, 15}, {9, 1}, {9, 3}, {9, 5}, {9, 7}, {9, 9}, {9, 11}, {9, 13}, {9, 15}, {11, 1}, {11, 3}, {11, 5}, {11, 7}, {11, 9}, {11, 11}, {11, 13}, {11, 15}, {13, 1}, {13, 3}, {13, 5}, {13, 7}, {13, 9}, {13, 11}, {13, 13}, {13, 15}, {15, 1}, {15, 3}, {15, 5}, {15, 7}, {15, 9}, {15, 11}, {15, 13}, {15, 15}}}, 
{{17, 5}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {4, 3}, {4, 6}, {4, 9}, {4, 12}, {4, 15}, {6, 2}, {6, 5}, {6, 8}, {6, 11}, {6, 14}, {8, 3}, {8, 6}, {8, 9}, {8, 12}, {8, 15}, {10, 2}, {10, 5}, {10, 8}, {10, 11}, {10, 14}, {12, 3}, {12, 6}, {12, 9}, {12, 12}, {12, 15}, {14, 2}, {14, 5}, {14, 8}, {14, 13}, {15, 10}, {15, 15}}}, 
{{17, 8}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {5, 2}, {5, 5}, {5, 8}, {5, 11}, {5, 14}, {8, 2}, {8, 5}, {8, 8}, {8, 11}, {8, 14}, {11, 2}, {11, 5}, {11, 8}, {11, 11}, {11, 14}, {14, 2}, {14, 5}, {14, 8}, {14, 11}, {14, 14}}}, 
{{17, 9}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {5, 2}, {5, 5}, {5, 8}, {5, 11}, {5, 14}, {8, 2}, {8, 5}, {8, 8}, {8, 11}, {8, 14}, {11, 2}, {11, 5}, {11, 8}, {11, 11}, {11, 14}, {14, 2}, {14, 5}, {14, 8}, {14, 11}, {14, 14}}}, 
{{17, 10}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {5, 3}, {5, 7}, {5, 11}, {5, 15}, {8, 2}, {8, 6}, {8, 10}, {8, 14}, {11, 3}, {11, 7}, {11, 11}, {11, 15}, {14, 2}, {14, 12}, {15, 5}, {15, 9}, {15, 15}}}, 
{{17, 13}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {5, 4}, {5, 8}, {5, 12}, {7, 15}, {8, 2}, {8, 6}, {8, 10}, {10, 13}, {11, 4}, {11, 8}, {13, 11}, {13, 15}, {14, 2}, {14, 6}}}, 
{{17, 16}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {6, 2}, {6, 6}, {6, 10}, {6, 14}, {10, 2}, {10, 6}, {10, 10}, {10, 14}, {14, 2}, {14, 6}, {14, 10}, {14, 14}}}, 
{{17, 17}, {{3, 3}, {3, 8}, {3, 13}, {7, 4}, {7, 10}, {8, 14}, {10, 7}, {11, 3}, {11, 11}, {14, 6}, {14, 14}}}, 
{{17, 18}, {{3, 3}, {3, 8}, {3, 13}, {7, 5}, {7, 11}, {10, 8}, {10, 14}, {11, 3}, {13, 11}, {14, 6}}}, 
{{18, 1}, {{1, 1}, {1, 2}, {1, 3}, {1, 4}, {1, 5}, {1, 6}, {1, 7}, {1, 8}, {1, 9}, {1, 10}, {1, 11}, {1, 12}, {1, 13}, {1, 14}, {1, 15}, {1, 16}, {1, 17}, {2, 1}, {2, 2}, {2, 3}, {2, 4}, {2, 5}, {2, 6}, {2, 7}, {2, 8}, {2, 9}, {2, 10}, {2, 11}, {2, 12}, {2, 13}, {2, 14}, {2, 15}, {2, 16}, {2, 17}, {3, 1}, {3, 2}, {3, 3}, {3, 4}, {3, 5}, {3, 6}, {3, 7}, {3, 8}, {3, 9}, {3, 10}, {3, 11}, {3, 12}, {3, 13}, {3, 14}, {3, 15}, {3, 16}, {3, 17}, {4, 1}, {4, 2}, {4, 3}, {4, 4}, {4, 5}, {4, 6}, {4, 7}, {4, 8}, {4, 9}, {4, 10}, {4, 11}, {4, 12}, {4, 13}, {4, 14}, {4, 15}, {4, 16}, {4, 17}, {5, 1}, {5, 2}, {5, 3}, {5, 4}, {5, 5}, {5, 6}, {5, 7}, {5, 8}, {5, 9}, {5, 10}, {5, 11}, {5, 12}, {5, 13}, {5, 14}, {5, 15}, {5, 16}, {5, 17}, {6, 1}, {6, 2}, {6, 3}, {6, 4}, {6, 5}, {6, 6}, {6, 7}, {6, 8}, {6, 9}, {6, 10}, {6, 11}, {6, 12}, {6, 13}, {6, 14}, {6, 15}, {6, 16}, {6, 17}, {7, 1}, {7, 2}, {7, 3}, {7, 4}, {7, 5}, {7, 6}, {7, 7}, {7, 8}, {7, 9}, {7, 10}, {7, 11}, {7, 12}, {7, 13}, {7, 14}, {7, 15}, {7, 16}, {7, 17}, {8, 1}, {8, 2}, {8, 3}, {8, 4}, {8, 5}, {8, 6}, {8, 7}, {8, 8}, {8, 9}, {8, 10}, {8, 11}, {8, 12}, {8, 13}, {8, 14}, {8, 15}, {8, 16}, {8, 17}, {9, 1}, {9, 2}, {9, 3}, {9, 4}, {9, 5}, {9, 6}, {9, 7}, {9, 8}, {9, 9}, {9, 10}, {9, 11}, {9, 12}, {9, 13}, {9, 14}, {9, 15}, {9, 16}, {9, 17}, {10, 1}, {10, 2}, {10, 3}, {10, 4}, {10, 5}, {10, 6}, {10, 7}, {10, 8}, {10, 9}, {10, 10}, {10, 11}, {10, 12}, {10, 13}, {10, 14}, {10, 15}, {10, 16}, {10, 17}, {11, 1}, {11, 2}, {11, 3}, {11, 4}, {11, 5}, {11, 6}, {11, 7}, {11, 8}, {11, 9}, {11, 10}, {11, 11}, {11, 12}, {11, 13}, {11, 14}, {11, 15}, {11, 16}, {11, 17}, {12, 1}, {12, 2}, {12, 3}, {12, 4}, {12, 5}, {12, 6}, {12, 7}, {12, 8}, {12, 9}, {12, 10}, {12, 11}, {12, 12}, {12, 13}, {12, 14}, {12, 15}, {12, 16}, {12, 17}, {13, 1}, {13, 2}, {13, 3}, {13, 4}, {13, 5}, {13, 6}, {13, 7}, {13, 8}, {13, 9}, {13, 10}, {13, 11}, {13, 12}, {13, 13}, {13, 14}, {13, 15}, {13, 16}, {13, 17}, {14, 1}, {14, 2}, {14, 3}, {14, 4}, {14, 5}, {14, 6}, {14, 7}, {14, 8}, {14, 9}, {14, 10}, {14, 11}, {14, 12}, {14, 13}, {14, 14}, {14, 15}, {14, 16}, {14, 17}, {15, 1}, {15, 2}, {15, 3}, {15, 4}, {15, 5}, {15, 6}, {15, 7}, {15, 8}, {15, 9}, {15, 10}, {15, 11}, {15, 12}, {15, 13}, {15, 14}, {15, 15}, {15, 16}, {15, 17}, {16, 1}, {16, 2}, {16, 3}, {16, 4}, {16, 5}, {16, 6}, {16, 7}, {16, 8}, {16, 9}, {16, 10}, {16, 11}, {16, 12}, {16, 13}, {16, 14}, {16, 15}, {16, 16}, {16, 17}, {17, 1}, {17, 2}, {17, 3}, {17, 4}, {17, 5}, {17, 6}, {17, 7}, {17, 8}, {17, 9}, {17, 10}, {17, 11}, {17, 12}, {17, 13}, {17, 14}, {17, 15}, {17, 16}, {17, 17}}}, 
{{18, 2}, {{1, 1}, {1, 3}, {1, 5}, {1, 7}, {1, 9}, {1, 11}, {1, 13}, {1, 15}, {1, 17}, {2, 2}, {2, 4}, {2, 6}, {2, 8}, {2, 10}, {2, 12}, {2, 14}, {2, 16}, {3, 1}, {3, 3}, {3, 5}, {3, 7}, {3, 9}, {3, 11}, {3, 13}, {3, 15}, {3, 17}, {4, 2}, {4, 4}, {4, 6}, {4, 8}, {4, 10}, {4, 12}, {4, 14}, {4, 16}, {5, 1}, {5, 3}, {5, 5}, {5, 7}, {5, 9}, {5, 11}, {5, 13}, {5, 15}, {5, 17}, {6, 2}, {6, 4}, {6, 6}, {6, 8}, {6, 10}, {6, 12}, {6, 14}, {6, 16}, {7, 1}, {7, 3}, {7, 5}, {7, 7}, {7, 9}, {7, 11}, {7, 13}, {7, 15}, {7, 17}, {8, 2}, {8, 4}, {8, 6}, {8, 8}, {8, 10}, {8, 12}, {8, 14}, {8, 16}, {9, 1}, {9, 3}, {9, 5}, {9, 7}, {9, 9}, {9, 11}, {9, 13}, {9, 15}, {9, 17}, {10, 2}, {10, 4}, {10, 6}, {10, 8}, {10, 10}, {10, 12}, {10, 14}, {10, 16}, {11, 1}, {11, 3}, {11, 5}, {11, 7}, {11, 9}, {11, 11}, {11, 13}, {11, 15}, {11, 17}, {12, 2}, {12, 4}, {12, 6}, {12, 8}, {12, 10}, {12, 12}, {12, 14}, {12, 16}, {13, 1}, {13, 3}, {13, 5}, {13, 7}, {13, 9}, {13, 11}, {13, 13}, {13, 15}, {13, 17}, {14, 2}, {14, 4}, {14, 6}, {14, 8}, {14, 10}, {14, 12}, {14, 14}, {14, 16}, {15, 1}, {15, 3}, {15, 5}, {15, 7}, {15, 9}, {15, 11}, {15, 13}, {15, 15}, {15, 17}, {16, 2}, {16, 4}, {16, 6}, {16, 8}, {16, 10}, {16, 12}, {16, 14}, {16, 16}, {17, 1}, {17, 3}, {17, 5}, {17, 7}, {17, 9}, {17, 11}, {17, 13}, {17, 15}, {17, 17}}}, 
{{18, 4}, {{1, 1}, {1, 3}, {1, 5}, {1, 7}, {1, 9}, {1, 11}, {1, 13}, {1, 15}, {1, 17}, {3, 1}, {3, 3}, {3, 5}, {3, 7}, {3, 9}, {3, 11}, {3, 13}, {3, 15}, {3, 17}, {5, 1}, {5, 3}, {5, 5}, {5, 7}, {5, 9}, {5, 11}, {5, 13}, {5, 15}, {5, 17}, {7, 1}, {7, 3}, {7, 5}, {7, 7}, {7, 9}, {7, 11}, {7, 13}, {7, 15}, {7, 17}, {9, 1}, {9, 3}, {9, 5}, {9, 7}, {9, 9}, {9, 11}, {9, 13}, {9, 15}, {9, 17}, {11, 1}, {11, 3}, {11, 5}, {11, 7}, {11, 9}, {11, 11}, {11, 13}, {11, 15}, {11, 17}, {13, 1}, {13, 3}, {13, 5}, {13, 7}, {13, 9}, {13, 11}, {13, 13}, {13, 15}, {13, 17}, {15, 1}, {15, 3}, {15, 5}, {15, 7}, {15, 9}, {15, 11}, {15, 13}, {15, 15}, {15, 17}, {17, 1}, {17, 3}, {17, 5}, {17, 7}, {17, 9}, {17, 11}, {17, 13}, {17, 15}, {17, 17}}}, 
{{18, 5}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {3, 16}, {4, 3}, {4, 6}, {4, 9}, {4, 12}, {5, 14}, {6, 2}, {6, 5}, {6, 8}, {6, 11}, {6, 16}, {7, 13}, {8, 3}, {8, 6}, {8, 9}, {8, 15}, {9, 11}, {10, 2}, {10, 5}, {10, 8}, {10, 13}, {10, 16}, {11, 10}, {12, 3}, {12, 6}, {12, 12}, {12, 15}, {13, 8}, {14, 2}, {14, 5}, {14, 10}, {14, 13}, {14, 16}, {15, 7}, {16, 3}, {16, 9}, {16, 12}, {16, 15}}}, 
{{18, 8}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {4, 16}, {5, 2}, {5, 5}, {5, 8}, {5, 11}, {6, 14}, {8, 2}, {8, 5}, {8, 8}, {8, 11}, {8, 16}, {10, 13}, {11, 2}, {11, 5}, {11, 8}, {11, 16}, {12, 11}, {13, 14}, {14, 2}, {14, 5}, {14, 8}, {15, 16}, {16, 10}, {16, 13}}}, 
{{18, 9}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {5, 2}, {5, 5}, {5, 8}, {5, 11}, {5, 14}, {8, 2}, {8, 5}, {8, 8}, {8, 11}, {8, 14}, {11, 2}, {11, 5}, {11, 8}, {11, 11}, {11, 14}, {14, 2}, {14, 5}, {14, 8}, {14, 11}, {14, 14}}}, 
{{18, 10}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {5, 3}, {5, 7}, {5, 11}, {5, 15}, {8, 2}, {8, 6}, {8, 10}, {8, 14}, {11, 3}, {11, 7}, {11, 13}, {12, 10}, {12, 16}, {14, 2}, {14, 6}, {15, 9}, {15, 13}, {16, 16}}}, 
{{18, 13}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {5, 4}, {5, 8}, {5, 12}, {5, 16}, {8, 2}, {8, 6}, {8, 10}, {8, 14}, {11, 4}, {11, 8}, {11, 12}, {11, 16}, {14, 2}, {14, 6}, {14, 10}, {14, 14}}}, 
{{18, 16}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {6, 2}, {6, 6}, {6, 10}, {6, 16}, {9, 13}, {10, 2}, {10, 6}, {12, 10}, {12, 16}, {14, 2}, {14, 6}, {16, 10}, {16, 14}}}, 
{{18, 17}, {{3, 3}, {3, 8}, {3, 14}, {6, 11}, {7, 7}, {7, 15}, {8, 3}, {10, 10}, {11, 6}, {11, 14}, {14, 3}, {14, 9}, {15, 13}}}, 
{{18, 18}, {{3, 3}, {3, 8}, {3, 13}, {7, 5}, {7, 10}, {7, 15}, {11, 3}, {11, 8}, {11, 13}, {15, 5}, {15, 10}, {15, 15}}}, 
{{19, 1}, {{1, 1}, {1, 2}, {1, 3}, {1, 4}, {1, 5}, {1, 6}, {1, 7}, {1, 8}, {1, 9}, {1, 10}, {1, 11}, {1, 12}, {1, 13}, {1, 14}, {1, 15}, {1, 16}, {1, 17}, {1, 18}, {2, 1}, {2, 2}, {2, 3}, {2, 4}, {2, 5}, {2, 6}, {2, 7}, {2, 8}, {2, 9}, {2, 10}, {2, 11}, {2, 12}, {2, 13}, {2, 14}, {2, 15}, {2, 16}, {2, 17}, {2, 18}, {3, 1}, {3, 2}, {3, 3}, {3, 4}, {3, 5}, {3, 6}, {3, 7}, {3, 8}, {3, 9}, {3, 10}, {3, 11}, {3, 12}, {3, 13}, {3, 14}, {3, 15}, {3, 16}, {3, 17}, {3, 18}, {4, 1}, {4, 2}, {4, 3}, {4, 4}, {4, 5}, {4, 6}, {4, 7}, {4, 8}, {4, 9}, {4, 10}, {4, 11}, {4, 12}, {4, 13}, {4, 14}, {4, 15}, {4, 16}, {4, 17}, {4, 18}, {5, 1}, {5, 2}, {5, 3}, {5, 4}, {5, 5}, {5, 6}, {5, 7}, {5, 8}, {5, 9}, {5, 10}, {5, 11}, {5, 12}, {5, 13}, {5, 14}, {5, 15}, {5, 16}, {5, 17}, {5, 18}, {6, 1}, {6, 2}, {6, 3}, {6, 4}, {6, 5}, {6, 6}, {6, 7}, {6, 8}, {6, 9}, {6, 10}, {6, 11}, {6, 12}, {6, 13}, {6, 14}, {6, 15}, {6, 16}, {6, 17}, {6, 18}, {7, 1}, {7, 2}, {7, 3}, {7, 4}, {7, 5}, {7, 6}, {7, 7}, {7, 8}, {7, 9}, {7, 10}, {7, 11}, {7, 12}, {7, 13}, {7, 14}, {7, 15}, {7, 16}, {7, 17}, {7, 18}, {8, 1}, {8, 2}, {8, 3}, {8, 4}, {8, 5}, {8, 6}, {8, 7}, {8, 8}, {8, 9}, {8, 10}, {8, 11}, {8, 12}, {8, 13}, {8, 14}, {8, 15}, {8, 16}, {8, 17}, {8, 18}, {9, 1}, {9, 2}, {9, 3}, {9, 4}, {9, 5}, {9, 6}, {9, 7}, {9, 8}, {9, 9}, {9, 10}, {9, 11}, {9, 12}, {9, 13}, {9, 14}, {9, 15}, {9, 16}, {9, 17}, {9, 18}, {10, 1}, {10, 2}, {10, 3}, {10, 4}, {10, 5}, {10, 6}, {10, 7}, {10, 8}, {10, 9}, {10, 10}, {10, 11}, {10, 12}, {10, 13}, {10, 14}, {10, 15}, {10, 16}, {10, 17}, {10, 18}, {11, 1}, {11, 2}, {11, 3}, {11, 4}, {11, 5}, {11, 6}, {11, 7}, {11, 8}, {11, 9}, {11, 10}, {11, 11}, {11, 12}, {11, 13}, {11, 14}, {11, 15}, {11, 16}, {11, 17}, {11, 18}, {12, 1}, {12, 2}, {12, 3}, {12, 4}, {12, 5}, {12, 6}, {12, 7}, {12, 8}, {12, 9}, {12, 10}, {12, 11}, {12, 12}, {12, 13}, {12, 14}, {12, 15}, {12, 16}, {12, 17}, {12, 18}, {13, 1}, {13, 2}, {13, 3}, {13, 4}, {13, 5}, {13, 6}, {13, 7}, {13, 8}, {13, 9}, {13, 10}, {13, 11}, {13, 12}, {13, 13}, {13, 14}, {13, 15}, {13, 16}, {13, 17}, {13, 18}, {14, 1}, {14, 2}, {14, 3}, {14, 4}, {14, 5}, {14, 6}, {14, 7}, {14, 8}, {14, 9}, {14, 10}, {14, 11}, {14, 12}, {14, 13}, {14, 14}, {14, 15}, {14, 16}, {14, 17}, {14, 18}, {15, 1}, {15, 2}, {15, 3}, {15, 4}, {15, 5}, {15, 6}, {15, 7}, {15, 8}, {15, 9}, {15, 10}, {15, 11}, {15, 12}, {15, 13}, {15, 14}, {15, 15}, {15, 16}, {15, 17}, {15, 18}, {16, 1}, {16, 2}, {16, 3}, {16, 4}, {16, 5}, {16, 6}, {16, 7}, {16, 8}, {16, 9}, {16, 10}, {16, 11}, {16, 12}, {16, 13}, {16, 14}, {16, 15}, {16, 16}, {16, 17}, {16, 18}, {17, 1}, {17, 2}, {17, 3}, {17, 4}, {17, 5}, {17, 6}, {17, 7}, {17, 8}, {17, 9}, {17, 10}, {17, 11}, {17, 12}, {17, 13}, {17, 14}, {17, 15}, {17, 16}, {17, 17}, {17, 18}, {18, 1}, {18, 2}, {18, 3}, {18, 4}, {18, 5}, {18, 6}, {18, 7}, {18, 8}, {18, 9}, {18, 10}, {18, 11}, {18, 12}, {18, 13}, {18, 14}, {18, 15}, {18, 16}, {18, 17}, {18, 18}}}, 
{{19, 2}, {{1, 1}, {1, 3}, {1, 5}, {1, 7}, {1, 9}, {1, 11}, {1, 13}, {1, 15}, {1, 17}, {2, 2}, {2, 4}, {2, 6}, {2, 8}, {2, 10}, {2, 12}, {2, 14}, {2, 16}, {2, 18}, {3, 1}, {3, 3}, {3, 5}, {3, 7}, {3, 9}, {3, 11}, {3, 13}, {3, 15}, {3, 17}, {4, 2}, {4, 4}, {4, 6}, {4, 8}, {4, 10}, {4, 12}, {4, 14}, {4, 16}, {4, 18}, {5, 1}, {5, 3}, {5, 5}, {5, 7}, {5, 9}, {5, 11}, {5, 13}, {5, 15}, {5, 17}, {6, 2}, {6, 4}, {6, 6}, {6, 8}, {6, 10}, {6, 12}, {6, 14}, {6, 16}, {6, 18}, {7, 1}, {7, 3}, {7, 5}, {7, 7}, {7, 9}, {7, 11}, {7, 13}, {7, 15}, {7, 17}, {8, 2}, {8, 4}, {8, 6}, {8, 8}, {8, 10}, {8, 12}, {8, 14}, {8, 16}, {8, 18}, {9, 1}, {9, 3}, {9, 5}, {9, 7}, {9, 9}, {9, 11}, {9, 13}, {9, 15}, {9, 17}, {10, 2}, {10, 4}, {10, 6}, {10, 8}, {10, 10}, {10, 12}, {10, 14}, {10, 16}, {10, 18}, {11, 1}, {11, 3}, {11, 5}, {11, 7}, {11, 9}, {11, 11}, {11, 13}, {11, 15}, {11, 17}, {12, 2}, {12, 4}, {12, 6}, {12, 8}, {12, 10}, {12, 12}, {12, 14}, {12, 16}, {12, 18}, {13, 1}, {13, 3}, {13, 5}, {13, 7}, {13, 9}, {13, 11}, {13, 13}, {13, 15}, {13, 17}, {14, 2}, {14, 4}, {14, 6}, {14, 8}, {14, 10}, {14, 12}, {14, 14}, {14, 16}, {14, 18}, {15, 1}, {15, 3}, {15, 5}, {15, 7}, {15, 9}, {15, 11}, {15, 13}, {15, 15}, {15, 17}, {16, 2}, {16, 4}, {16, 6}, {16, 8}, {16, 10}, {16, 12}, {16, 14}, {16, 16}, {16, 18}, {17, 1}, {17, 3}, {17, 5}, {17, 7}, {17, 9}, {17, 11}, {17, 13}, {17, 15}, {17, 17}, {18, 2}, {18, 4}, {18, 6}, {18, 8}, {18, 10}, {18, 12}, {18, 14}, {18, 16}, {18, 18}}}, 
{{19, 4}, {{1, 1}, {1, 3}, {1, 5}, {1, 7}, {1, 9}, {1, 11}, {1, 13}, {1, 15}, {1, 17}, {3, 1}, {3, 3}, {3, 5}, {3, 7}, {3, 9}, {3, 11}, {3, 13}, {3, 15}, {3, 17}, {5, 1}, {5, 3}, {5, 5}, {5, 7}, {5, 9}, {5, 11}, {5, 13}, {5, 15}, {5, 17}, {7, 1}, {7, 3}, {7, 5}, {7, 7}, {7, 9}, {7, 11}, {7, 13}, {7, 15}, {7, 17}, {9, 1}, {9, 3}, {9, 5}, {9, 7}, {9, 9}, {9, 11}, {9, 13}, {9, 15}, {9, 17}, {11, 1}, {11, 3}, {11, 5}, {11, 7}, {11, 9}, {11, 11}, {11, 13}, {11, 15}, {11, 17}, {13, 1}, {13, 3}, {13, 5}, {13, 7}, {13, 9}, {13, 11}, {13, 13}, {13, 15}, {13, 17}, {15, 1}, {15, 3}, {15, 5}, {15, 7}, {15, 9}, {15, 11}, {15, 13}, {15, 15}, {15, 17}, {17, 1}, {17, 3}, {17, 5}, {17, 7}, {17, 9}, {17, 11}, {17, 13}, {17, 15}, {17, 17}}}, 
{{19, 5}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {2, 17}, {4, 3}, {4, 6}, {4, 9}, {4, 12}, {4, 15}, {5, 17}, {6, 2}, {6, 5}, {6, 8}, {6, 11}, {6, 14}, {7, 16}, {8, 3}, {8, 6}, {8, 9}, {8, 12}, {9, 14}, {9, 17}, {10, 2}, {10, 5}, {10, 8}, {10, 11}, {11, 13}, {11, 16}, {12, 3}, {12, 6}, {12, 9}, {13, 11}, {13, 14}, {13, 17}, {14, 2}, {14, 5}, {14, 8}, {15, 10}, {15, 13}, {15, 16}, {16, 3}, {16, 6}, {17, 8}, {17, 11}, {17, 14}, {17, 17}}}, 
{{19, 8}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {2, 17}, {5, 2}, {5, 5}, {5, 8}, {5, 11}, {5, 14}, {5, 17}, {8, 2}, {8, 5}, {8, 8}, {8, 11}, {8, 14}, {8, 17}, {11, 2}, {11, 5}, {11, 8}, {11, 11}, {11, 14}, {11, 17}, {14, 2}, {14, 5}, {14, 8}, {14, 11}, {14, 14}, {14, 17}, {17, 2}, {17, 5}, {17, 8}, {17, 11}, {17, 14}, {17, 17}}}, 
{{19, 9}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {2, 17}, {5, 2}, {5, 5}, {5, 8}, {5, 11}, {5, 14}, {5, 17}, {8, 2}, {8, 5}, {8, 8}, {8, 11}, {8, 14}, {8, 17}, {11, 2}, {11, 5}, {11, 8}, {11, 11}, {11, 14}, {11, 17}, {14, 2}, {14, 5}, {14, 8}, {14, 11}, {14, 14}, {14, 17}, {17, 2}, {17, 5}, {17, 8}, {17, 11}, {17, 14}, {17, 17}}}, 
{{19, 10}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {3, 17}, {5, 3}, {5, 7}, {5, 11}, {6, 14}, {7, 17}, {8, 2}, {8, 6}, {8, 10}, {9, 13}, {10, 16}, {11, 3}, {11, 7}, {12, 10}, {13, 13}, {13, 17}, {14, 2}, {14, 6}, {15, 9}, {16, 12}, {16, 16}, {17, 3}}}, 
{{19, 13}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {4, 17}, {5, 4}, {5, 8}, {5, 12}, {7, 15}, {8, 2}, {8, 6}, {8, 10}, {10, 13}, {10, 17}, {11, 4}, {11, 8}, {13, 11}, {13, 15}, {14, 2}, {14, 6}, {16, 9}, {16, 13}, {16, 17}, {17, 4}}}, 
{{19, 16}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {5, 17}, {6, 2}, {6, 6}, {6, 10}, {8, 14}, {10, 2}, {10, 6}, {10, 10}, {11, 17}, {13, 13}, {14, 2}, {14, 6}, {15, 17}, {17, 9}, {17, 13}}}, 
{{19, 17}, {{3, 3}, {3, 8}, {3, 13}, {6, 16}, {7, 4}, {7, 12}, {8, 8}, {10, 15}, {11, 3}, {11, 11}, {12, 7}, {14, 16}, {15, 4}, {15, 12}, {16, 8}}}, 
{{19, 18}, {{3, 3}, {3, 8}, {3, 13}, {6, 16}, {7, 5}, {7, 10}, {11, 3}, {11, 8}, {11, 16}, {13, 12}, {16, 3}, {16, 8}, {16, 15}}}, 
{{20, 1}, {{1, 1}, {1, 2}, {1, 3}, {1, 4}, {1, 5}, {1, 6}, {1, 7}, {1, 8}, {1, 9}, {1, 10}, {1, 11}, {1, 12}, {1, 13}, {1, 14}, {1, 15}, {1, 16}, {1, 17}, {1, 18}, {1, 19}, {2, 1}, {2, 2}, {2, 3}, {2, 4}, {2, 5}, {2, 6}, {2, 7}, {2, 8}, {2, 9}, {2, 10}, {2, 11}, {2, 12}, {2, 13}, {2, 14}, {2, 15}, {2, 16}, {2, 17}, {2, 18}, {2, 19}, {3, 1}, {3, 2}, {3, 3}, {3, 4}, {3, 5}, {3, 6}, {3, 7}, {3, 8}, {3, 9}, {3, 10}, {3, 11}, {3, 12}, {3, 13}, {3, 14}, {3, 15}, {3, 16}, {3, 17}, {3, 18}, {3, 19}, {4, 1}, {4, 2}, {4, 3}, {4, 4}, {4, 5}, {4, 6}, {4, 7}, {4, 8}, {4, 9}, {4, 10}, {4, 11}, {4, 12}, {4, 13}, {4, 14}, {4, 15}, {4, 16}, {4, 17}, {4, 18}, {4, 19}, {5, 1}, {5, 2}, {5, 3}, {5, 4}, {5, 5}, {5, 6}, {5, 7}, {5, 8}, {5, 9}, {5, 10}, {5, 11}, {5, 12}, {5, 13}, {5, 14}, {5, 15}, {5, 16}, {5, 17}, {5, 18}, {5, 19}, {6, 1}, {6, 2}, {6, 3}, {6, 4}, {6, 5}, {6, 6}, {6, 7}, {6, 8}, {6, 9}, {6, 10}, {6, 11}, {6, 12}, {6, 13}, {6, 14}, {6, 15}, {6, 16}, {6, 17}, {6, 18}, {6, 19}, {7, 1}, {7, 2}, {7, 3}, {7, 4}, {7, 5}, {7, 6}, {7, 7}, {7, 8}, {7, 9}, {7, 10}, {7, 11}, {7, 12}, {7, 13}, {7, 14}, {7, 15}, {7, 16}, {7, 17}, {7, 18}, {7, 19}, {8, 1}, {8, 2}, {8, 3}, {8, 4}, {8, 5}, {8, 6}, {8, 7}, {8, 8}, {8, 9}, {8, 10}, {8, 11}, {8, 12}, {8, 13}, {8, 14}, {8, 15}, {8, 16}, {8, 17}, {8, 18}, {8, 19}, {9, 1}, {9, 2}, {9, 3}, {9, 4}, {9, 5}, {9, 6}, {9, 7}, {9, 8}, {9, 9}, {9, 10}, {9, 11}, {9, 12}, {9, 13}, {9, 14}, {9, 15}, {9, 16}, {9, 17}, {9, 18}, {9, 19}, {10, 1}, {10, 2}, {10, 3}, {10, 4}, {10, 5}, {10, 6}, {10, 7}, {10, 8}, {10, 9}, {10, 10}, {10, 11}, {10, 12}, {10, 13}, {10, 14}, {10, 15}, {10, 16}, {10, 17}, {10, 18}, {10, 19}, {11, 1}, {11, 2}, {11, 3}, {11, 4}, {11, 5}, {11, 6}, {11, 7}, {11, 8}, {11, 9}, {11, 10}, {11, 11}, {11, 12}, {11, 13}, {11, 14}, {11, 15}, {11, 16}, {11, 17}, {11, 18}, {11, 19}, {12, 1}, {12, 2}, {12, 3}, {12, 4}, {12, 5}, {12, 6}, {12, 7}, {12, 8}, {12, 9}, {12, 10}, {12, 11}, {12, 12}, {12, 13}, {12, 14}, {12, 15}, {12, 16}, {12, 17}, {12, 18}, {12, 19}, {13, 1}, {13, 2}, {13, 3}, {13, 4}, {13, 5}, {13, 6}, {13, 7}, {13, 8}, {13, 9}, {13, 10}, {13, 11}, {13, 12}, {13, 13}, {13, 14}, {13, 15}, {13, 16}, {13, 17}, {13, 18}, {13, 19}, {14, 1}, {14, 2}, {14, 3}, {14, 4}, {14, 5}, {14, 6}, {14, 7}, {14, 8}, {14, 9}, {14, 10}, {14, 11}, {14, 12}, {14, 13}, {14, 14}, {14, 15}, {14, 16}, {14, 17}, {14, 18}, {14, 19}, {15, 1}, {15, 2}, {15, 3}, {15, 4}, {15, 5}, {15, 6}, {15, 7}, {15, 8}, {15, 9}, {15, 10}, {15, 11}, {15, 12}, {15, 13}, {15, 14}, {15, 15}, {15, 16}, {15, 17}, {15, 18}, {15, 19}, {16, 1}, {16, 2}, {16, 3}, {16, 4}, {16, 5}, {16, 6}, {16, 7}, {16, 8}, {16, 9}, {16, 10}, {16, 11}, {16, 12}, {16, 13}, {16, 14}, {16, 15}, {16, 16}, {16, 17}, {16, 18}, {16, 19}, {17, 1}, {17, 2}, {17, 3}, {17, 4}, {17, 5}, {17, 6}, {17, 7}, {17, 8}, {17, 9}, {17, 10}, {17, 11}, {17, 12}, {17, 13}, {17, 14}, {17, 15}, {17, 16}, {17, 17}, {17, 18}, {17, 19}, {18, 1}}}, 
{{20, 2}, {{1, 1}, {1, 3}, {1, 5}, {1, 7}, {1, 9}, {1, 11}, {1, 13}, {1, 15}, {1, 17}, {1, 19}, {2, 2}, {2, 4}, {2, 6}, {2, 8}, {2, 10}, {2, 12}, {2, 14}, {2, 16}, {2, 18}, {3, 1}, {3, 3}, {3, 5}, {3, 7}, {3, 9}, {3, 11}, {3, 13}, {3, 15}, {3, 17}, {3, 19}, {4, 2}, {4, 4}, {4, 6}, {4, 8}, {4, 10}, {4, 12}, {4, 14}, {4, 16}, {4, 18}, {5, 1}, {5, 3}, {5, 5}, {5, 7}, {5, 9}, {5, 11}, {5, 13}, {5, 15}, {5, 17}, {5, 19}, {6, 2}, {6, 4}, {6, 6}, {6, 8}, {6, 10}, {6, 12}, {6, 14}, {6, 16}, {6, 18}, {7, 1}, {7, 3}, {7, 5}, {7, 7}, {7, 9}, {7, 11}, {7, 13}, {7, 15}, {7, 17}, {7, 19}, {8, 2}, {8, 4}, {8, 6}, {8, 8}, {8, 10}, {8, 12}, {8, 14}, {8, 16}, {8, 18}, {9, 1}, {9, 3}, {9, 5}, {9, 7}, {9, 9}, {9, 11}, {9, 13}, {9, 15}, {9, 17}, {9, 19}, {10, 2}, {10, 4}, {10, 6}, {10, 8}, {10, 10}, {10, 12}, {10, 14}, {10, 16}, {10, 18}, {11, 1}, {11, 3}, {11, 5}, {11, 7}, {11, 9}, {11, 11}, {11, 13}, {11, 15}, {11, 17}, {11, 19}, {12, 2}, {12, 4}, {12, 6}, {12, 8}, {12, 10}, {12, 12}, {12, 14}, {12, 16}, {12, 18}, {13, 1}, {13, 3}, {13, 5}, {13, 7}, {13, 9}, {13, 11}, {13, 13}, {13, 15}, {13, 17}, {13, 19}, {14, 2}, {14, 4}, {14, 6}, {14, 8}, {14, 10}, {14, 12}, {14, 14}, {14, 16}, {14, 18}, {15, 1}, {15, 3}, {15, 5}, {15, 7}, {15, 9}, {15, 11}, {15, 13}, {15, 15}, {15, 17}, {15, 19}, {16, 2}, {16, 4}, {16, 6}, {16, 8}, {16, 10}, {16, 12}, {16, 14}, {16, 16}, {16, 18}, {17, 1}, {17, 3}, {17, 5}, {17, 7}, {17, 9}, {17, 11}, {17, 13}, {17, 15}, {17, 17}, {17, 19}}}, 
{{20, 4}, {{1, 1}, {1, 3}, {1, 5}, {1, 7}, {1, 9}, {1, 11}, {1, 13}, {1, 15}, {1, 17}, {1, 19}, {3, 1}, {3, 3}, {3, 5}, {3, 7}, {3, 9}, {3, 11}, {3, 13}, {3, 15}, {3, 17}, {3, 19}, {5, 1}, {5, 3}, {5, 5}, {5, 7}, {5, 9}, {5, 11}, {5, 13}, {5, 15}, {5, 17}, {5, 19}, {7, 1}, {7, 3}, {7, 5}, {7, 7}, {7, 9}, {7, 11}, {7, 13}, {7, 15}, {7, 17}, {7, 19}, {9, 1}, {9, 3}, {9, 5}, {9, 7}, {9, 9}, {9, 11}, {9, 13}, {9, 15}, {9, 17}, {9, 19}, {11, 1}, {11, 3}, {11, 5}, {11, 7}, {11, 9}, {11, 11}, {11, 13}, {11, 15}, {11, 17}, {11, 19}, {13, 1}, {13, 3}, {13, 5}, {13, 7}, {13, 9}, {13, 11}, {13, 13}, {13, 15}, {13, 17}, {13, 19}, {15, 1}, {15, 3}, {15, 5}, {15, 7}, {15, 9}, {15, 11}, {15, 13}, {15, 15}, {15, 17}, {15, 19}, {17, 1}, {17, 3}, {17, 5}, {17, 7}, {17, 9}, {17, 11}, {17, 13}, {17, 15}, {17, 17}, {17, 19}}}, 
{{20, 5}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {2, 17}, {4, 3}, {4, 6}, {4, 9}, {4, 12}, {4, 15}, {4, 18}, {6, 2}, {6, 5}, {6, 8}, {6, 11}, {6, 14}, {6, 17}, {8, 3}, {8, 6}, {8, 9}, {8, 12}, {8, 15}, {8, 18}, {10, 2}, {10, 5}, {10, 8}, {10, 11}, {10, 14}, {10, 17}, {12, 3}, {12, 6}, {12, 9}, {12, 12}, {12, 15}, {12, 18}, {14, 2}, {14, 5}, {14, 8}, {14, 11}, {14, 14}, {14, 17}, {16, 3}, {16, 6}, {16, 9}, {16, 12}, {16, 15}, {16, 18}, {18, 2}, {18, 5}, {18, 8}, {18, 11}, {18, 14}, {18, 17}}}, 
{{20, 8}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {2, 17}, {5, 2}, {5, 5}, {5, 8}, {5, 11}, {5, 14}, {5, 17}, {8, 2}, {8, 5}, {8, 8}, {8, 11}, {8, 14}, {8, 17}, {11, 2}, {11, 5}, {11, 8}, {11, 11}, {11, 14}, {11, 17}, {14, 2}, {14, 5}, {14, 8}, {14, 11}, {14, 14}, {14, 17}, {17, 2}, {17, 5}, {17, 8}, {17, 11}, {17, 14}, {17, 17}}}, 
{{20, 9}, {{2, 2}, {2, 5}, {2, 8}, {2, 11}, {2, 14}, {2, 17}, {5, 2}, {5, 5}, {5, 8}, {5, 11}, {5, 14}, {5, 17}, {8, 2}, {8, 5}, {8, 8}, {8, 11}, {8, 14}, {8, 17}, {11, 2}, {11, 5}, {11, 8}, {11, 11}, {11, 14}, {11, 17}, {14, 2}, {14, 5}, {14, 8}, {14, 11}, {14, 14}, {14, 17}, {17, 2}, {17, 5}, {17, 8}, {17, 11}, {17, 14}, {17, 17}}}, 
{{20, 10}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {2, 18}, {5, 3}, {5, 7}, {5, 11}, {5, 15}, {6, 18}, {8, 2}, {8, 6}, {8, 10}, {8, 14}, {9, 17}, {11, 3}, {11, 7}, {11, 11}, {12, 14}, {12, 18}, {14, 2}, {14, 6}, {14, 10}, {15, 13}, {15, 17}, {17, 3}, {17, 7}, {18, 10}, {18, 14}, {18, 18}}}, 
{{20, 13}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {2, 18}, {5, 4}, {5, 8}, {5, 12}, {5, 16}, {8, 2}, {8, 6}, {8, 10}, {8, 14}, {8, 18}, {11, 4}, {11, 8}, {11, 12}, {11, 16}, {14, 2}, {14, 6}, {14, 10}, {14, 14}, {14, 18}, {18, 2}, {18, 6}, {18, 10}, {18, 14}, {18, 18}}}, 
{{20, 16}, {{2, 2}, {2, 6}, {2, 10}, {2, 14}, {2, 18}, {6, 2}, {6, 6}, {6, 10}, {6, 14}, {6, 18}, {10, 2}, {10, 6}, {10, 10}, {10, 14}, {10, 18}, {14, 2}, {14, 6}, {14, 10}, {14, 14}, {14, 18}, {18, 2}, {18, 6}, {18, 10}, {18, 14}, {18, 18}}}, 
{{20, 17}, {{3, 3}, {3, 8}, {3, 13}, {4, 17}, {7, 4}, {7, 10}, {9, 17}, {10, 7}, {10, 13}, {11, 3}, {13, 10}, {13, 16}, {15, 4}, {16, 13}, {17, 8}, {17, 17}}}
};

void cliq(vector<B> &eds, B P = ~B(), B X={}, B R={}) {
    if(!P.any()) {
        int res = R.count();
        if(res > ans) {
            ans = res;
            lans = R;
        } 
        return;
    }
    auto q = (P | X)._Find_first();
    auto cands = P & ~eds[q];
    if((int)(R.count() + cands.count()) <= ans) return;
    FOR(i, 0, SZ(eds)) if(cands[i]) {
        R[i] = 1;
        cliq(eds, P & eds[i], X & eds[i], R);
        R[i] = P[i] = 0; X[i] = 1;
    }
}

void solve() {
    int n;
    double r;
    cin >> n >> r;
    if(n == 2 * r && n % 2 == 1) {
        cout << "0\n";
        return;
    }
    double co = 4 * r * r;
    for(auto &[par, arg]: memo) {
        auto [nx, nr] = par;
        if(nx == n && nr - 1e-6 <= co) {
            cout << SZ(arg) << '\n';
            for(auto &[x, y]: arg) cout << x << ' ' << y << '\n';
            return;
        }
    }
    map<pii, int> ind;
    map<int, pii> rind;
    int nr = 0;
    int bound = ceil(r);
    rep(i, bound, n-bound) rep(j, bound, n-bound) {
        rind[nr] = {i, j};
        ind[{i, j}] = nr++;
    }
    vector<B> g(nr);
    set<int> dists;
    rep(i, bound, n-bound) rep(j, bound, n-bound) rep(k, bound, n-bound) rep(l, bound, n-bound) {
        int dst = (i - k) * (i - k) + (j - l) * (j - l);
        if(dst >= 4 * r * r - 1e-3) g[ind[{i, j}]][ind[{k, l}]] = 1;
        dists.insert(dst);
    }
    // deb(SZ(dists));
    // deb(dists);
    cliq(g);
    cout << ans << '\n';
    FOR(i, 0, nr) if(lans[i]) cout << rind[i].st << ' ' << rind[i].nd << '\n';
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
    int tt = 1;
    // cin >> tt;

    
    FOR(te, 0, tt) solve();
    return 0;
}